# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from jsk_interactive_marker/MoveModel.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import sensor_msgs.msg
import std_msgs.msg

class MoveModel(genpy.Message):
  _md5sum = "61edcddd6ca50e876e68d4fcf06c90f6"
  _type = "jsk_interactive_marker/MoveModel"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header
string name
string description
sensor_msgs/JointState joint_state_origin
sensor_msgs/JointState joint_state_goal
geometry_msgs/PoseStamped pose_origin
geometry_msgs/PoseStamped pose_goal


================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w
"""
  __slots__ = ['header','name','description','joint_state_origin','joint_state_goal','pose_origin','pose_goal']
  _slot_types = ['std_msgs/Header','string','string','sensor_msgs/JointState','sensor_msgs/JointState','geometry_msgs/PoseStamped','geometry_msgs/PoseStamped']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,name,description,joint_state_origin,joint_state_goal,pose_origin,pose_goal

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(MoveModel, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.name is None:
        self.name = ''
      if self.description is None:
        self.description = ''
      if self.joint_state_origin is None:
        self.joint_state_origin = sensor_msgs.msg.JointState()
      if self.joint_state_goal is None:
        self.joint_state_goal = sensor_msgs.msg.JointState()
      if self.pose_origin is None:
        self.pose_origin = geometry_msgs.msg.PoseStamped()
      if self.pose_goal is None:
        self.pose_goal = geometry_msgs.msg.PoseStamped()
    else:
      self.header = std_msgs.msg.Header()
      self.name = ''
      self.description = ''
      self.joint_state_origin = sensor_msgs.msg.JointState()
      self.joint_state_goal = sensor_msgs.msg.JointState()
      self.pose_origin = geometry_msgs.msg.PoseStamped()
      self.pose_goal = geometry_msgs.msg.PoseStamped()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_state_origin.header.seq, _x.joint_state_origin.header.stamp.secs, _x.joint_state_origin.header.stamp.nsecs))
      _x = self.joint_state_origin.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state_origin.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state_origin.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state_origin.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state_origin.position))
      length = len(self.joint_state_origin.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state_origin.velocity))
      length = len(self.joint_state_origin.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state_origin.effort))
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_state_goal.header.seq, _x.joint_state_goal.header.stamp.secs, _x.joint_state_goal.header.stamp.nsecs))
      _x = self.joint_state_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state_goal.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state_goal.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state_goal.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state_goal.position))
      length = len(self.joint_state_goal.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state_goal.velocity))
      length = len(self.joint_state_goal.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state_goal.effort))
      _x = self
      buff.write(_get_struct_3I().pack(_x.pose_origin.header.seq, _x.pose_origin.header.stamp.secs, _x.pose_origin.header.stamp.nsecs))
      _x = self.pose_origin.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.pose_origin.pose.position.x, _x.pose_origin.pose.position.y, _x.pose_origin.pose.position.z, _x.pose_origin.pose.orientation.x, _x.pose_origin.pose.orientation.y, _x.pose_origin.pose.orientation.z, _x.pose_origin.pose.orientation.w, _x.pose_goal.header.seq, _x.pose_goal.header.stamp.secs, _x.pose_goal.header.stamp.nsecs))
      _x = self.pose_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.pose_goal.pose.position.x, _x.pose_goal.pose.position.y, _x.pose_goal.pose.position.z, _x.pose_goal.pose.orientation.x, _x.pose_goal.pose.orientation.y, _x.pose_goal.pose.orientation.z, _x.pose_goal.pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.joint_state_origin is None:
        self.joint_state_origin = sensor_msgs.msg.JointState()
      if self.joint_state_goal is None:
        self.joint_state_goal = sensor_msgs.msg.JointState()
      if self.pose_origin is None:
        self.pose_origin = geometry_msgs.msg.PoseStamped()
      if self.pose_goal is None:
        self.pose_goal = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.description = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.description = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.joint_state_origin.header.seq, _x.joint_state_origin.header.stamp.secs, _x.joint_state_origin.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state_origin.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state_origin.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state_origin.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state_origin.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_origin.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_origin.velocity = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_origin.effort = s.unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.joint_state_goal.header.seq, _x.joint_state_goal.header.stamp.secs, _x.joint_state_goal.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state_goal.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state_goal.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state_goal.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_goal.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_goal.velocity = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_goal.effort = s.unpack(str[start:end])
      _x = self
      start = end
      end += 12
      (_x.pose_origin.header.seq, _x.pose_origin.header.stamp.secs, _x.pose_origin.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_origin.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_origin.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.pose_origin.pose.position.x, _x.pose_origin.pose.position.y, _x.pose_origin.pose.position.z, _x.pose_origin.pose.orientation.x, _x.pose_origin.pose.orientation.y, _x.pose_origin.pose.orientation.z, _x.pose_origin.pose.orientation.w, _x.pose_goal.header.seq, _x.pose_goal.header.stamp.secs, _x.pose_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.pose_goal.pose.position.x, _x.pose_goal.pose.position.y, _x.pose_goal.pose.position.z, _x.pose_goal.pose.orientation.x, _x.pose_goal.pose.orientation.y, _x.pose_goal.pose.orientation.z, _x.pose_goal.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_state_origin.header.seq, _x.joint_state_origin.header.stamp.secs, _x.joint_state_origin.header.stamp.nsecs))
      _x = self.joint_state_origin.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state_origin.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state_origin.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state_origin.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state_origin.position.tostring())
      length = len(self.joint_state_origin.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state_origin.velocity.tostring())
      length = len(self.joint_state_origin.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state_origin.effort.tostring())
      _x = self
      buff.write(_get_struct_3I().pack(_x.joint_state_goal.header.seq, _x.joint_state_goal.header.stamp.secs, _x.joint_state_goal.header.stamp.nsecs))
      _x = self.joint_state_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state_goal.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state_goal.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state_goal.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state_goal.position.tostring())
      length = len(self.joint_state_goal.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state_goal.velocity.tostring())
      length = len(self.joint_state_goal.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state_goal.effort.tostring())
      _x = self
      buff.write(_get_struct_3I().pack(_x.pose_origin.header.seq, _x.pose_origin.header.stamp.secs, _x.pose_origin.header.stamp.nsecs))
      _x = self.pose_origin.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d3I().pack(_x.pose_origin.pose.position.x, _x.pose_origin.pose.position.y, _x.pose_origin.pose.position.z, _x.pose_origin.pose.orientation.x, _x.pose_origin.pose.orientation.y, _x.pose_origin.pose.orientation.z, _x.pose_origin.pose.orientation.w, _x.pose_goal.header.seq, _x.pose_goal.header.stamp.secs, _x.pose_goal.header.stamp.nsecs))
      _x = self.pose_goal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.pose_goal.pose.position.x, _x.pose_goal.pose.position.y, _x.pose_goal.pose.position.z, _x.pose_goal.pose.orientation.x, _x.pose_goal.pose.orientation.y, _x.pose_goal.pose.orientation.z, _x.pose_goal.pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.joint_state_origin is None:
        self.joint_state_origin = sensor_msgs.msg.JointState()
      if self.joint_state_goal is None:
        self.joint_state_goal = sensor_msgs.msg.JointState()
      if self.pose_origin is None:
        self.pose_origin = geometry_msgs.msg.PoseStamped()
      if self.pose_goal is None:
        self.pose_goal = geometry_msgs.msg.PoseStamped()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.description = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.description = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.joint_state_origin.header.seq, _x.joint_state_origin.header.stamp.secs, _x.joint_state_origin.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state_origin.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state_origin.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state_origin.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state_origin.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_origin.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_origin.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_origin.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.joint_state_goal.header.seq, _x.joint_state_goal.header.stamp.secs, _x.joint_state_goal.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state_goal.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state_goal.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state_goal.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_goal.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_goal.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state_goal.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      _x = self
      start = end
      end += 12
      (_x.pose_origin.header.seq, _x.pose_origin.header.stamp.secs, _x.pose_origin.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_origin.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_origin.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 68
      (_x.pose_origin.pose.position.x, _x.pose_origin.pose.position.y, _x.pose_origin.pose.position.z, _x.pose_origin.pose.orientation.x, _x.pose_origin.pose.orientation.y, _x.pose_origin.pose.orientation.z, _x.pose_origin.pose.orientation.w, _x.pose_goal.header.seq, _x.pose_goal.header.stamp.secs, _x.pose_goal.header.stamp.nsecs,) = _get_struct_7d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_goal.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.pose_goal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.pose_goal.pose.position.x, _x.pose_goal.pose.position.y, _x.pose_goal.pose.position.z, _x.pose_goal.pose.orientation.x, _x.pose_goal.pose.orientation.y, _x.pose_goal.pose.orientation.z, _x.pose_goal.pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_7d3I = None
def _get_struct_7d3I():
    global _struct_7d3I
    if _struct_7d3I is None:
        _struct_7d3I = struct.Struct("<7d3I")
    return _struct_7d3I
